require 'logger'
require 'date'
require 'savon'

module Wedoops
    module MasmovilSmsclient
        class Client

            def initialize(options=Wedoops::MasmovilSmsclient::Configuration.new)
                @logger = Logger.new(STDOUT)   
                @config = options
                @proxy = nil
                setup_proxy if @config.option.has_key?(:proxy)
                initialize_client
            end

            def sendSMS
                @logger.info("Calling thing...")
                message = {
                    :user => "APPSimplant19",
                    :pass => "h6pG0S60",
                    :src => "+34619766776",
                    :dst => "+34619766776",
                    :msg => "Yeep",
                    :date => DateTime.now,
                    :name => "pepe"
                }
                begin
                   # pp @client
                    response = @client.call(:send_sms) do
                        message(message)
                    end
                rescue Exception => e
                    @logger.error("Error sending SMS: #{e.message}")
                    return nil
                end
                return response
            end

            private

            def initialize_client
                @logger.debug("Initlizing savon")
                unless @proxy.nil?
                    # TO-DO: Fix the authentication as needed
                    #secret = Base64.strict_encode64("#{@proxy[:user]}:#{@proxy[:password]}")
                    #@logger.debug(@proxy)
                    
                    #header={ "Proxy-Authorization" => "Basic #{secret}","Authorization" => "Basic"}
                    #@logger.debug(header)
                    @client = Savon.client(
                        wsdl: 'https://websms.xtratelecom.es/api_php/server.wsdl',
                        pretty_print_xml: true,
                        #convert_request_keys_to :camelcase
                        log: true,
                        log_level: :info,
                        logger: @logger,
                       # basic_auth: [@proxy[:user],@proxy[:password]] ,
                        filters: [:password],
                        proxy: "#{@proxy[:address]}",
                        #headers: header
                    )
                else
                    @client = Savon.client(
                        wsdl: 'https://websms.xtratelecom.es/api_php/server.wsdl',
                        pretty_print_xml: true,
                        #convert_request_keys_to :camelcase
                        log: true,
                        log_level: :debug,
                    )
                end
 
               # end
            end

            def setup_proxy
                @proxy = @config.option[:proxy]
            end


        end
    end
end